// ISoldat.cpp: implementation of the ISoldat class.
//
//////////////////////////////////////////////////////////////////////

#include "ISoldat.h"

#define VIDAMOVIMENTS 30

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ISoldat::ISoldat()
{
	bEstaMort = false;
	Vida=0;
	Tipus=0;
	point2 po(0,0);
	Posicio.Init(po,90);
}

ISoldat::~ISoldat()
{

}

ISoldat::ISoldat(point2 lloc)
{
	// Dades del grfic

	Tipus = 0;  // Sense Paracaigures
	GraficsTo(Tipus);

	// Els soldats sempre cauen avall ... 		
	Posicio.Init(lloc,90);	
	Velocitat = 5;
	
	bEstaMort = false;
	Vida = VIDAMOVIMENTS;

	MidaParacaigudes.Assign(50,32);

	// Li haig de dir que de aqui una estona
	// deixi anar el paracaigudes
	So[0]=0;
	So[1]=1;
}


int ISoldat::Tocat(const SDL_Rect &Bala)
{
	switch (Tipus)
	{
		case 0:
		case 2:
		case 3:
			Tipus = 6;
			GraficsTo(6);
			break;
		case 1:		// Comprovar on toca? 
				if (SiTocaParacaigudes(Bala))
				{					
					Tipus=2;
					GraficsTo(2);
				}
				else
				{				
					Tipus=6;
					GraficsTo(6);
				}
				break;
		// default: // No pot passar...
	}
		
	return true;
}

void ISoldat::Mou()
{
	switch (Tipus)
	{
		case 0:
		case 2:
			if (Vida==0)
			{
				Tipus++;					
				GraficsTo(Tipus);
			}
			else 
			{
				Vida--;
			}
			break;
		case 4:
		case 6:	
			if (Vida==0)
			{
				// Kill Object
				bEstaMort = true;
				return;
			}
			else
			{
				Vida--;
			}
			break;
	}
	// 1, 3 i 5 noms cauen ... 
	// 0, 2 desprs de fer el que han de fer tamb
	// 4 i 6 tamb, si no es moren ... 
	ISprite::Mou();
}

// Retorna si arriba viu
bool ISoldat::ArribaABaix()
{
	bool bRetorn;
	// Ha arribat a baix! 
	//        5: sense problemes!
	//        4: mort!
	if (Tipus==1)
	{
		Tipus = 5;
		bRetorn = true;
	}
	else 
	{
		Tipus = 4;			
		bRetorn = false;
	}
	GraficsTo(Tipus);
	// TRAMPA per col.locar els soldats a lloc
	Posicio.Coord.y = 480 - Mida.y - 5;

	return bRetorn;
}

void ISoldat::GraficsTo(int i)
{
	switch (i)
	{
		// Sense paracaigures
		case 0: 	
			Mida.Assign(32,31);
			GraficAvanca.Assign(33,0);
			GraficPosicio.Assign(0,1);
			GraficPrimer.Assign(0,1);
			GraficsNumero=5;
			GraficNumActual=0;
			GraficCanviaCada=3;
			GraficPassada=0;

			Vida = VIDAMOVIMENTS;
			Velocitat = 8;
			break;
		// Obre el paracaigures
		case 1:	
			Mida.Assign(50,68);
			GraficAvanca.Assign(51,0);
			GraficPosicio.Assign(0,33);
			GraficPrimer.Assign(0,33);
			GraficsNumero=5;
			GraficNumActual=0;
			GraficCanviaCada=2;
			GraficPassada=0;

			Velocitat = 4;
			break;
		// Tocat el paracaigudes
		case 2:	
			Mida.Assign(50,71);
			GraficAvanca.Assign(51,0);
			GraficPosicio.Assign(0,181);
			GraficPrimer.Assign(0,181);
			GraficsNumero=5;
			GraficNumActual=0;
			GraficCanviaCada=2;
			GraficPassada=0;
			
			Vida = VIDAMOVIMENTS;
			Velocitat = 5;
			break;
		// Cau sense paracaigudes
		case 3:	
			Mida.Assign(31,38);
			GraficAvanca.Assign(32,0);
			GraficPosicio.Assign(0,142);
			GraficPrimer.Assign(0,142);
			GraficsNumero=4;
			GraficNumActual=0;
			GraficCanviaCada=3;
			GraficPassada=0;

			Velocitat = 6;
			break;
		// Toca a terra sense paracaigudes
		case 4:	
			Mida.Assign(45,39);
			GraficAvanca.Assign(46,0);
			GraficPosicio.Assign(128,102);
			GraficPrimer.Assign(128,102);
			GraficsNumero=2;
			GraficNumActual=0;
			GraficCanviaCada=3;
			GraficPassada=0;

			Vida = VIDAMOVIMENTS;
			Velocitat = 0;
			break;
		// Arriba a baix amb paracaigudes
		case 5:	
			Mida.Assign(31,38);
			GraficAvanca.Assign(32,0);
			GraficPosicio.Assign(0,102);
			GraficPrimer.Assign(0,102);
			GraficsNumero=4;
			GraficNumActual=0;
			GraficCanviaCada=40;
			GraficPassada=0;

			Velocitat = 0;
			break;
		// Tocat per una bala
		case 6:	
			Mida.Assign(50,50);
			GraficAvanca.Assign(51,0);
			GraficPosicio.Assign(0,254);
			GraficPrimer.Assign(0,254);
			GraficsNumero=5;
			GraficNumActual=0;
			GraficCanviaCada=1;
			GraficPassada=0;

			Velocitat = 0;			
			Vida = VIDAMOVIMENTS;
			break;
	}
}

// Comprova si hem tocat el paracaigudes
bool ISoldat::SiTocaParacaigudes(const SDL_Rect p)
{
	bool bResultat=false;
	SDL_Rect Paraca, Resultat;

	Paraca.y = Posicio.Coord.y;
	Paraca.x = Posicio.Coord.x;
	Paraca.h = MidaParacaigudes.y;
	Paraca.w = MidaParacaigudes.x;

	if (IntersectRect(&Resultat,&Paraca,&p)) bResultat=true;

	return bResultat;									
}

bool ISoldat::IsMort()
{
	return bEstaMort;
}
