#ifdef WIN32
#pragma comment(lib, "SDL.lib")
#pragma comment(lib, "SDLmain.lib")
#pragma comment(lib, "SDL_mixer.lib")
#endif

#include <vector>
using namespace std ;

#include "General.h"
#include "IAvio.h"
#include "ISoldat.h"
#include "IProjectil.h"
#include "ICano.h"

#include "Marcador.h"

#ifdef DREAMCAST
#include <kos.h>
#include <sdl_dreamcast.h>
extern uint8 romdisk[];
KOS_INIT_ROMDISK(romdisk);
#endif

/* 
typedef vector<IAvio*, allocator<int> > VectorAvions ;
typedef VectorAvions::iterator iterAvions;

typedef vector<ISoldat*, allocator<int> > VectorSoldats;
typedef VectorSoldats::iterator iterSoldats;

typedef vector<IProjectil*, allocator<int> >VectorProjectils;
typedef VectorProjectils::iterator iterProjectils;
*/
typedef vector<IAvio*> VectorAvions;
typedef VectorAvions::iterator iterAvions;
typedef vector<ISoldat*> VectorSoldats;
typedef VectorSoldats::iterator iterSoldats;
typedef vector<IProjectil*> VectorProjectils;
typedef VectorProjectils::iterator iterProjectils;

SDL_Surface *pantalla;
SDL_Surface *Fondo;
SDL_Surface *Sprites;


ICano Poum;
Marcador *marcador;


VectorAvions m_avions;
VectorSoldats m_paraques;
VectorProjectils m_bales;

int NumPantalla;
// long punts;
Uint32 timeAnterior;
float ProvabiAvio;
int Escapats;
int CanviAngle;
long Record[2];
SDL_Rect MidaPantalla;

/* Subsistema de so --------------------------------------------------------------------
*  ( ---------------------------------------- )
*
*/
Mix_Chunk *Fressa[SONS];

void PlaySound(int num)
{
   	if(Mix_PlayChannel(-1, Fressa[num], 0)==-1) {
    //error
	}
}
bool SoundLoad(char* Nom,int i)
{
	Fressa[i]=Mix_LoadWAV(Nom);
	return true;

}
void SoundDelete()
{
	for (int i=0; i<SONS; i++) 
	{
		if (Fressa[i]!=NULL) Mix_FreeChunk(Fressa[i]);
		Fressa[i]=NULL;//make sure we free it
	}
}

/* Subsistema grfic --------------------------------------------------------------------
*  ( ---------------------------------------- )
*
*/

void Slock(SDL_Surface *pantalla)
{
  if ( SDL_MUSTLOCK(pantalla) )
  {
    if ( SDL_LockSurface(pantalla) < 0 )
    {
      return;
    }
  }
}

void Sulock(SDL_Surface *pantalla)
{
  if ( SDL_MUSTLOCK(pantalla) )
  {
    SDL_UnlockSurface(pantalla);
  }
}

void PintaImatge(SDL_Surface *img, int x, int y)
{
  SDL_Rect dest;
  dest.x = x;
  dest.y = y;
  SDL_BlitSurface(img, NULL, pantalla, &dest);
}


bool PintaReverse(SDL_Rect Origen, SDL_Rect Desti)
{
	
	// Primer em faig una superficie que contindr noms la imatge a mostrar...
	SDL_Surface *Temp = SDL_CreateRGBSurface(SDL_HWSURFACE, Origen.w, Origen.h, 
		                                     Sprites->format->BitsPerPixel, Sprites->format->Rmask,
											 Sprites->format->Gmask, Sprites->format->Bmask,
											 Sprites->format->Amask);
	// Copio la imatge a la nova superficie
	if(!Temp)return NULL;

	SDL_Rect dest;
	dest.x = 0;
	dest.y = 0;
	SDL_BlitSurface(Sprites, &Origen, Temp, &dest);
	// Ara la giro i la creo a Girada
	SDL_Surface *Girada = FlipSurfaceH(Temp);
	// Assignar el color transparent
	SDL_SetColorKey(Girada, SDL_SRCCOLORKEY , SDL_MapRGB(Girada->format, 0, 0, 0));
	// Pintar la imatge definitivament a la 'pantalla'
	SDL_BlitSurface(Girada, &dest, pantalla, &Desti);
	// Allibero memria
	SDL_FreeSurface(Girada);
	SDL_FreeSurface(Temp);
	return false;
}

bool Pinta(SDL_Rect Origen, SDL_Rect Desti)
{
	return SDL_BlitSurface(Sprites, &Origen, pantalla, &Desti);	
}

/* freeVectors() --------------------------------------------------------------------
*  Allibera els vectors de dades de la feina a fer.
*
*/ 

void freeVectors()
{
	iterSoldats its;
	iterAvions its2;
	iterProjectils its3;

	for (its=m_paraques.begin(); its!=m_paraques.end(); its++)
	{
			delete *its;	
	}
	m_paraques.clear();

	for (its2=m_avions.begin(); its2!=m_avions.end(); its2++)
	{
			delete (*its2);
	}
	m_avions.clear();
	for (its3=m_bales.begin(); its3!=m_bales.end(); its3++)
	{
			delete (*its3);
	}
	m_bales.clear();
}

/*
* Col.lisions --------------------------------------------------------------------
* Comprovar les possibles col.lisions amb una bala
*  (s la nica cosa que pot col.lisionar...)
*
*/

bool Colisiona(SDL_Rect bala)
{
	iterSoldats its;
	iterAvions its2;

	SDL_Rect Collide;


	its = m_paraques.begin();
	bool bTocat = false;
	while (its!=m_paraques.end() && !bTocat)
	{
		SDL_Rect Target = (*its)->GetPosRectangle();
		if (IntersectRect(&Collide,&bala,&Target))
		{
			// Touch!			
			(*its)->Tocat(bala);
			PlaySound(2);
			marcador->Suma(5);
			//punts +=5;
			// Esborrar la bala
			bTocat = true;
		}
		else its++;
	}

	if (!bTocat)
	{
		// Comprova amb els helicopters
		its2 = m_avions.begin();
		while (its2!=m_avions.end() && !bTocat)
		{
			SDL_Rect Target = (*its2)->GetPosRectangle ();
			if (IntersectRect(&Collide,&bala,&Target))
			{
				(*its2)->Tocat();
				PlaySound(1);
				bTocat=true;
				marcador->Suma(10);
				//punts+=10;
			}
			else its2++;
		}
	}

	int Increment = (int) marcador->getPunts() / 100; 
	ProvabiAvio = 0.01f + Increment*0.001f;
	return bTocat;

}

/*
* Moviment bales --------------------------------------------------------------------
*
*/
void MovimentBales()
{
	// Desplaament de les bales i comprovacions diverses
	// 1. Ha de moure els soldats cap avall	
	iterProjectils it;

	it = m_bales.begin();
	while (it != m_bales.end())
	{
		(*it)->Mou();
		
		SDL_Rect Origen = (*it)->GetGraficRectangle();
		SDL_Rect Desti = (*it)->GetPosRectangle();
		SDL_Rect Collide;

		if (!IntersectRect(&Collide,&Desti,&MidaPantalla))
		{
			// S'ha d'eliminar
			delete (*it);
			m_bales.erase(it);

		}
		else
		{
			// Comprova col.lisi amb paraques i helicopters			
			if (Colisiona(Desti))
			{
				delete(*it);
				m_bales.erase(it);
			}
			else
			{
				// S'ha de pintar
				Pinta(Origen,Desti);
				it++;
			}


		}
		if (m_bales.empty()) break;
		// it++;
	}
}

/*
* Moviment Paraques --------------------------------------------------------------------
*
*/

void MovimentParaques()
{
	// 1. Ha de moure els soldats cap avall	
	iterSoldats it;

	it = m_paraques.begin();
	while (it != m_paraques.end())
	{
		(*it)->Mou();
		
		if ((*it)->IsMort())
		{
			// S'ha d'eliminar
			delete (*it);
			m_paraques.erase(it);

		}
		else
		{
			SDL_Rect Origen = (*it)->GetGraficRectangle();
			SDL_Rect Desti = (*it)->GetPosRectangle();
			SDL_Rect Resultat;
			
			IntersectRect(&Resultat,&Desti,&MidaPantalla);
			if (Resultat.h!=Desti.h)
			{			
				// Ha arribat a baix, i per tant haurem de 
				// comprovar que no ha colisionat amb ning ... 
				if ((*it)->ArribaABaix()) 
				{
					Escapats++;
					PlaySound(3);
				}
				//else PlaySound(4);
			}			
			// S'ha de pintar
			Pinta(Origen,Desti);
			it++;
		}
		if (m_paraques.empty()) break;
		
	}
}

/*
* Moviment avions --------------------------------------------------------------------
*
*/
bool MovimentAvions()
{
	// 0. Han d'apareixer avions? 
	if (ProvabiAvio > RandFloat())
	{
		m_avions.push_back( new IAvio(0.01f,3) );
	}
	
	// 1. Ha de moure tot el que hi ha a pantalla ( Si surt de pantalla
	//    llavors s'ha de matar a menys que sigui un soldat )
	//    --> Comprovar colisions entre soldats i afortunat --> Avisar a l'objecte
	// MouAvions();
	iterAvions it;
	it = m_avions.begin();
	while (it != m_avions.end())
	{
		(*it)->Mou();
		// Comprovar colisions i assignar les explosions!
		// --> Projectils: Soldats i Helicopters
		// 3. Pintar els dibuixos
		// Si est dins de la pantalla: pinta, sin mata!
		SDL_Rect Origen = (*it)->GetGraficRectangle();
		SDL_Rect Desti = (*it)->GetPosRectangle();
		SDL_Rect Collide;

		if (IntersectRect(&Collide,&Desti,&MidaPantalla))
		{
			
			if ((*it)->IsMort())
			{
				// S'ha d'eliminar
				delete (*it);
				m_avions.erase(it);
			}
			else
			{
				// Mirar si ha de cagar!!

				ISoldat* Militar = (*it)->Caga();
				if (Militar!=NULL)
				{
					// Afegir el soldat a la llista
					m_paraques.push_back(Militar);
				}

				// hr = Graphics()->GetBackBuffer()->Blt( &Desti, Sprites, &Origen,DDBLT_KEYSRC,NULL);
				if ((*it)->IsGirat()) PintaReverse(Origen,Desti);
							     else Pinta(Origen,Desti);
				it++;
			}
		}
		else
		{
			// Destruir l'objecte
			delete (*it);
			m_avions.erase(it);
		}
		// Si ens hem carregat tota la penya... sortir		
		if (m_avions.empty()) break;		
	}
	return true;
}


/* Principals
*  ( ------------------------------------------------------------------------
*     Carregar les dades necessries per cada imatge
*/

int IniciaImatges(int NumPantalla) 
{ 
	char Cami[25];
	
	sprintf(Cami,"/rd/P%d0.png",NumPantalla);

	Fondo = IMG_Load(Cami); 	
	// Pintar el fondo
	PintaImatge(Fondo,0,0);

	switch (NumPantalla) 
	{	
	case 0: 
		// Pantalla ZERO
		if (SoundLoad("/rd/militar.wav",5))
		{
			PlaySound(5);
		}
		Escapats=0;
		break;
	case 1:		
		/*
		**
		**Carregar grfic amb els sprites : Sprites
		**
		*/
		sprintf(Cami,"/rd/P%d1.png",NumPantalla);

		// dd=RGB(0,0,0);
		
		Sprites = IMG_Load(Cami); 
		SDL_SetColorKey(Sprites, SDL_SRCCOLORKEY , SDL_MapRGB(Sprites->format, 0, 0, 0));
		// Apagar el so anterior 
		Mix_FadeOutChannel(-1, 1000);
		
		SoundLoad("/rd/Tret.wav",0);
		SoundLoad("/rd/Boum.wav",1);
		SoundLoad("/rd/mort.wav",2);
		SoundLoad("/rd/iupi.wav",3);
		SoundLoad("/rd/puak.wav",4);
		// Inicialitzaci bsica ( punts, paraques escapats, ... ) 
		ProvabiAvio=0.01f;
		CanviAngle=0;
		//punts = 0;
		Escapats = 0;
		marcador = new Marcador(pantalla,300,448);
		break;
	case 2:
		Escapats=0;
		// Alliberar la memria ocupada abans...
		freeVectors();
		SoundLoad("/rd/end.wav",6);
                PlaySound(6);
		break;
	}	
	return 0;
}

/* Principals
*  ----------------------------------------------------------------------------------
*     Pintar el frame
*/


void PintaEscena(SDL_Surface *pantalla)
{
 	char sText[10];
	SDL_Rect Origen, Desti;
	
	if (Escapats>=10)
	{	
		NumPantalla++;
		IniciaImatges(NumPantalla);		
	}

	
	// Si no toca moure, esperar ... 
	Uint32 currTime = SDL_GetTicks();
	Uint32 delta = (currTime - timeAnterior);
	if (delta < ESPERA) return; 
	timeAnterior = currTime;
	
	// Repinta el fons de la pantalla
	PintaImatge(Fondo,0,0);

	// Segons la pantalla fer:
	switch (NumPantalla)
	{		
		case 0: 
			// Pantalla 0: noms cal demanar que premin F1
			strcpy(sText,"Prem F1");
			// Graphics()->DrawTextString(300,430,L'\xFFFF',sText);
			break;
		case 1:  
			// Pantalla 1: Moure les coses.
			// Moure el can, per no pintar-lo
			Poum.Mou(CanviAngle); 
			// Moure les bales i pintar-les
			MovimentBales();
			// Moure els avions i pintar-los
			MovimentAvions();
			// Moure els paraques i pintar-los
			MovimentParaques();
			// Pintar el can segons sigui...
			Origen = Poum.GetGraficRectangle();
			Desti = Poum.GetPosRectangle();
			if (Poum.IsGirat()) PintaReverse(Origen, Desti);
						   else Pinta(Origen,Desti);
			// Escriure els punts que tenim.			
			// _itoa(punts,sText,10);
			marcador->Pinta();
			// Graphics()->DrawTextString( 0, 0, 255, sText);
			break;
		case 2:
			marcador->Pinta();			
			if (marcador->getPunts()>Record[0])
			{
				Record[0] = marcador->getPunts();
				// WriteProfileString("Paraca","Record",sText);
			}
			break;			
	}
	SDL_Flip(pantalla);
}

/* Principals --------------------------------------------------------------------
*  
*     MAIN
*/

int main(int argc, char **argv)
{		
	printf("Starting...\n");

	/* inicialitza SDL */
	if ( SDL_Init( SDL_INIT_VIDEO | SDL_INIT_AUDIO | SDL_INIT_JOYSTICK ) < 0 )
	{
		fprintf( stderr, "Video initialization failed: %s\n",
		SDL_GetError( ) );
		SDL_Quit( );
	}

	pantalla = SDL_SetVideoMode(640, 480, 32, SDL_HWSURFACE|SDL_DOUBLEBUF);
	if ( pantalla == NULL ) 
	{ 
		printf("Unable to set %dx%d video: %s\n", MidaPantalla.w,MidaPantalla.h,SDL_GetError()); 
		return 1;
	} 
	
	atexit(SDL_Quit);
	
	//Sets control pad of Dreamcast
	#ifdef DREAMCAST
	SDL_DC_MapKey(0,SDL_DC_START,SDLK_F1); 
	SDL_DC_MapKey(0,SDL_DC_LEFT,SDLK_LEFT); 
	SDL_DC_MapKey(0,SDL_DC_RIGHT,SDLK_RIGHT);
	SDL_DC_MapKey(0,SDL_DC_A,SDLK_UP);
	SDL_DC_MapKey(0,SDL_DC_R,SDLK_ESCAPE); //L button
	
	SDL_JoystickEventState(SDL_ENABLE);
	SDL_JoystickOpen(0); 	
	SDL_DC_EmulateMouse(SDL_bool (false));
	SDL_ShowCursor(0);
	
	//Dreamcast delay...
	SDL_Delay(50);
	SDL_Event event;
	while(SDL_PollEvent(&event))
		SDL_Delay(20);
	#endif
	
	Mix_OpenAudio(MIX_DEFAULT_FREQUENCY,MIX_DEFAULT_FORMAT,1,4096);

	MidaPantalla.x = 0;
	MidaPantalla.y = 0;
	MidaPantalla.w = 640;
	MidaPantalla.h=480;

	// Iniciaci de variables

	NumPantalla = 0;	
	timeAnterior = SDL_GetTicks();


	// Carrega les imatges necessaries
	IniciaImatges(0);
	
	int done=0;

	while (done==0)
	{
		SDL_Event event;
		while ( SDL_PollEvent(&event))
		{
			if (event.type == SDL_QUIT) { done = 1; }

			if (event.type == SDL_KEYDOWN)
			{
				switch(event.key.keysym.sym)
				{
					case SDLK_ESCAPE:
						done = true;
						break;
					case SDLK_UP:
						if (NumPantalla==1)
						{
							// m_states[0]=1;
							PlaySound( 0 );
							CanviAngle = 0;			
							m_bales.push_back( Poum.Shot() );
							marcador->Resta(1);
							//punts--;
						}
						break;					
					case SDLK_LEFT:
						// if(!m_states[1])
						// {
						//	m_states[1]=1;
							// Moure el can a l'esquerra
						CanviAngle=-5;
						// }
						break;
					case SDLK_RIGHT:
						CanviAngle=5;
						break;
			        
					case SDLK_F1:
						switch (NumPantalla)
						{
							case 2:
								delete marcador;
							case 0:
								NumPantalla=1;
								IniciaImatges(NumPantalla);
								break;
						}
						break;
				}					
			}
		}
		PintaEscena(pantalla);
	}
	Mix_CloseAudio();
	return 0;
}
