#if !defined(_POINT2_H )
#define _POINT2_H


#define EPSILON 0.001
#include <math.h>

struct point2
{
	union
	{
		struct 
		{
			float x,y;
		};
		float v[2];

	};
	
	point2(){}

	point2(float X, float Y): 
		x(X), y(Y)
	{}
		
	void Assign(float X, float Y);

	point2& operator += ( const point2& in );
	point2& operator -= ( const point2& in );
	point2& operator *= ( const float& in );
	point2& operator /= ( const float& in );
	point2  operator -  (); // negaci ( ho recomana un llibre )	

};

// Operadors de la estructura
/**
*	Suma d'un vector al nostre +=
*/
inline point2& point2::operator += ( const point2& in )
{
	x += in.x;   
	y += in.y;   	
	return *this; // Retornant this podem encadenar operadors
}

/**
 * Resta d'un vector al nostre -=
 */
inline point2& point2::operator -= ( const point2& in )
{
	x -= in.x;   
	y -= in.y;   	
	return *this; 
}


/**
 * Multiplica
 */
inline point2& point2::operator *= ( const float& in )
{
	x *= in;   
	y *= in;   	
	return *this; 
}


/**
 * Divisi 
 */
inline point2& point2::operator /= ( const float& in )
{
	float inv = 1.f / in; 
	x *= inv;   
	y *= inv;   	
	return *this; 
}
/**
*	Canvi de signe
*/ 
inline point2 point2::operator - () 
{
	return point2(
		-x,
		-y		
	);
}

/**
*	Operaci suma: resultat = a + b
*/
inline const point2 operator+(point2 const &a, point2 const &b)
{
	return point2
	(
		a.x+b.x,
		a.y+b.y
	);
};
/**
*	Operaci resta: resultat = a - b
*/
inline const point2 operator-(point2 const &a, point2 const &b)
{
	return point2
	(
		a.x-b.x,
		a.y-b.y
	);
}


inline bool   operator==(point2 const &a, point2 const &b)

{
	if (fabs(a.x-b.x)<EPSILON)
	{
		if (fabs(a.y-b.y)<EPSILON)
		{
			return true;
		}
	}
	return false;
}


// --- Altres

inline void point2::Assign( float X, float Y)
{
	x=X;	
	y=Y;	
}



#endif /*_POINT2_H*/
